- Home
- Download

- GitHub

- News
- Documentation

- FAQ
- Tutorial
- API reference
- Examples

- XML Digital Signature
- XML Encryption
- XML Canonicalization
- Reporting Bugs
- Mailing list
- Related
- Authors

## crypto

crypto

## Stability Level

Stable, unless otherwise indicated

## Functions

xmlSecCryptoDLFunctionsPtr | xmlSecCryptoGetFunctions_openssl ()
int | xmlSecOpenSSLInit ()
int | xmlSecOpenSSLShutdown ()
int | xmlSecOpenSSLKeysMngrInit ()
int | xmlSecOpenSSLGenerateRandom ()
int | xmlSecOpenSSLSetDefaultTrustedCertsFolder ()
const xmlChar * | xmlSecOpenSSLGetDefaultTrustedCertsFolder ()
int | xmlSecOpenSSLSetLibCtx ()
OSSL_LIB_CTX * | xmlSecOpenSSLGetLibCtx ()
BIO * | xmlSecOpenSSLCreateMemBio ()
BIO * | xmlSecOpenSSLCreateMemBufBio ()
BIO * | xmlSecOpenSSLCreateReadFileBio ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataAesGetKlass ()
int | xmlSecOpenSSLKeyDataAesSet ()
xmlSecTransformId | xmlSecOpenSSLTransformAes128CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformAes192CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformAes256CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformAes128GcmGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformAes192GcmGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformAes256GcmGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWAes128GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWAes192GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWAes256GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataCamelliaGetKlass ()
int | xmlSecOpenSSLKeyDataCamelliaSet ()
xmlSecTransformId | xmlSecOpenSSLTransformCamellia128CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformCamellia192CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformCamellia256CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWCamellia128GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWCamellia192GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWCamellia256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformChaCha20GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformChaCha20Poly1305GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataChaCha20GetKlass ()
int | xmlSecOpenSSLKeyDataChaCha20Set ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataConcatKdfGetKlass ()
int | xmlSecOpenSSLKeyDataConcatKdfSet ()
xmlSecTransformId | xmlSecOpenSSLTransformConcatKdfGetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataDesGetKlass ()
int | xmlSecOpenSSLKeyDataDesSet ()
xmlSecTransformId | xmlSecOpenSSLTransformDes3CbcGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformKWDes3GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataDsaGetKlass ()
int | xmlSecOpenSSLKeyDataDsaAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataDsaGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformDsaSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformDsaSha256GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataDhGetKlass ()
int | xmlSecOpenSSLKeyDataDhAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataDhGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformDhEsGetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataEcGetKlass ()
int | xmlSecOpenSSLKeyDataEcAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataEcGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaRipemd160GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha3_224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha3_256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha3_384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdsaSha3_512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEcdhGetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataGost2001GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGostR3411_94GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGost2001GostR3411_94GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataGostR3410_2012_256GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataGostR3410_2012_512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGostR3411_2012_256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformGostR3411_2012_512GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataHmacGetKlass ()
int | xmlSecOpenSSLKeyDataHmacSet ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacMd5GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacRipemd160GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacSha224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacSha256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacSha384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformHmacSha512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformMd5GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataPbkdf2GetKlass ()
int | xmlSecOpenSSLKeyDataPbkdf2Set ()
xmlSecTransformId | xmlSecOpenSSLTransformPbkdf2GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataHkdfGetKlass ()
int | xmlSecOpenSSLKeyDataHkdfSet ()
xmlSecTransformId | xmlSecOpenSSLTransformHkdfGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRipemd160GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataRsaGetKlass ()
int | xmlSecOpenSSLKeyDataRsaAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataRsaGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaMd5GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaRipemd160GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaSha224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaSha256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaSha384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaSha512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPkcs1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaOaepGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaOaepEnc11GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha3_224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha3_256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha3_384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformRsaPssSha3_512GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataMLDSAGetKlass ()
int | xmlSecOpenSSLKeyDataMLDSAAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataMLDSAGetEvp ()
int | xmlSecOpenSSLKeyDataMLDSAGetKL ()
xmlSecTransformId | xmlSecOpenSSLTransformMLDSA44GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformMLDSA65GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformMLDSA87GetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataSLHDSAGetKlass ()
int | xmlSecOpenSSLKeyDataSLHDSAAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataSLHDSAGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_128fGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_128sGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_192fGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_192sGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_256fGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSLHDSA_SHA2_256sGetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataEdDSAGetKlass ()
int | xmlSecOpenSSLKeyDataEdDSAAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataEdDSAGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformEdDSAEd25519GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEdDSAEd25519ctxGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEdDSAEd25519phGetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEdDSAEd448GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformEdDSAEd448phGetKlass ()
xmlSecKeyDataId | xmlSecOpenSSLKeyDataXdhGetKlass ()
int | xmlSecOpenSSLKeyDataXdhAdoptEvp ()
EVP_PKEY * | xmlSecOpenSSLKeyDataXdhGetEvp ()
xmlSecTransformId | xmlSecOpenSSLTransformX25519GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformX448GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha1GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha512GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha3_224GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha3_256GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha3_384GetKlass ()
xmlSecTransformId | xmlSecOpenSSLTransformSha3_512GetKlass ()
void | xmlSecOpenSSLErrorsDefaultCallback ()

## Types and Values

#define | XMLSEC_OPENSSL_API_111
#define | XMLSEC_OPENSSL_API_350
#define | XMLSEC_OPENSSL_API_300
#define | XMLSEC_NO_AES
#define | XMLSEC_NO_CONCATKDF
#define | XMLSEC_NO_PBKDF2
#define | XMLSEC_NO_HKDF
#define | XMLSEC_NO_DES
#define | XMLSEC_NO_DSA
#define | XMLSEC_NO_EC
#define | XMLSEC_NO_GOST
#define | XMLSEC_NO_GOST2012
#define | XMLSEC_NO_HMAC
#define | XMLSEC_NO_MD5
#define | XMLSEC_NO_RIPEMD160
#define | XMLSEC_NO_RSA
#define | XMLSEC_NO_MLDSA
#define | XMLSEC_NO_SLHDSA
#define | XMLSEC_NO_EDDSA
#define | XMLSEC_NO_SHA1
#define | XMLSEC_NO_SHA256
#define | XMLSEC_NO_SHA224
#define | XMLSEC_NO_SHA384
#define | XMLSEC_NO_SHA512
#define | XMLSEC_NO_X509
#define | xmlSecOpenSSLKeyDataAesId
#define | xmlSecOpenSSLTransformAes128CbcId
#define | xmlSecOpenSSLTransformAes192CbcId
#define | xmlSecOpenSSLTransformAes256CbcId
#define | xmlSecOpenSSLTransformAes128GcmId
#define | xmlSecOpenSSLTransformAes192GcmId
#define | xmlSecOpenSSLTransformAes256GcmId
#define | xmlSecOpenSSLTransformKWAes128Id
#define | xmlSecOpenSSLTransformKWAes192Id
#define | xmlSecOpenSSLTransformKWAes256Id
#define | xmlSecOpenSSLKeyDataCamelliaId
#define | xmlSecOpenSSLTransformCamellia128CbcId
#define | xmlSecOpenSSLTransformCamellia192CbcId
#define | xmlSecOpenSSLTransformCamellia256CbcId
#define | xmlSecOpenSSLTransformKWCamellia128Id
#define | xmlSecOpenSSLTransformKWCamellia192Id
#define | xmlSecOpenSSLTransformKWCamellia256Id
#define | xmlSecOpenSSLTransformChaCha20Id
#define | xmlSecOpenSSLTransformChaCha20Poly1305Id
#define | xmlSecOpenSSLKeyDataChaCha20Id
#define | xmlSecOpenSSLKeyDataConcatKdfId
#define | xmlSecOpenSSLTransformConcatKdfId
#define | xmlSecOpenSSLKeyDataDesId
#define | xmlSecOpenSSLTransformDes3CbcId
#define | xmlSecOpenSSLTransformKWDes3Id
#define | xmlSecOpenSSLKeyDataDsaId
#define | xmlSecOpenSSLTransformDsaSha1Id
#define | xmlSecOpenSSLTransformDsaSha256Id
#define | xmlSecOpenSSLKeyDataDhId
#define | xmlSecOpenSSLTransformDhEsId
#define | xmlSecOpenSSLKeyDataEcId
#define | xmlSecOpenSSLTransformEcdsaRipemd160Id
#define | xmlSecOpenSSLTransformEcdsaSha1Id
#define | xmlSecOpenSSLTransformEcdsaSha224Id
#define | xmlSecOpenSSLTransformEcdsaSha256Id
#define | xmlSecOpenSSLTransformEcdsaSha384Id
#define | xmlSecOpenSSLTransformEcdsaSha512Id
#define | xmlSecOpenSSLTransformEcdsaSha3_224Id
#define | xmlSecOpenSSLTransformEcdsaSha3_256Id
#define | xmlSecOpenSSLTransformEcdsaSha3_384Id
#define | xmlSecOpenSSLTransformEcdsaSha3_512Id
#define | xmlSecOpenSSLTransformEcdhId
#define | xmlSecOpenSSLKeyDataGost2001Id
#define | xmlSecOpenSSLTransformGostR3411_94Id
#define | xmlSecOpenSSLTransformGost2001GostR3411_94Id
#define | xmlSecOpenSSLKeyDataGostR3410_2012_256Id
#define | xmlSecOpenSSLKeyDataGostR3410_2012_512Id
#define | xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256Id
#define | xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512Id
#define | xmlSecOpenSSLTransformGostR3411_2012_256Id
#define | xmlSecOpenSSLTransformGostR3411_2012_512Id
#define | xmlSecOpenSSLKeyDataHmacId
#define | xmlSecOpenSSLTransformHmacMd5Id
#define | xmlSecOpenSSLTransformHmacRipemd160Id
#define | xmlSecOpenSSLTransformHmacSha1Id
#define | xmlSecOpenSSLTransformHmacSha224Id
#define | xmlSecOpenSSLTransformHmacSha256Id
#define | xmlSecOpenSSLTransformHmacSha384Id
#define | xmlSecOpenSSLTransformHmacSha512Id
#define | xmlSecOpenSSLTransformMd5Id
#define | xmlSecOpenSSLKeyDataPbkdf2Id
#define | xmlSecOpenSSLTransformPbkdf2Id
#define | xmlSecOpenSSLKeyDataHkdfId
#define | xmlSecOpenSSLTransformHkdfId
#define | xmlSecOpenSSLTransformRipemd160Id
#define | xmlSecOpenSSLKeyDataRsaId
#define | xmlSecOpenSSLTransformRsaMd5Id
#define | xmlSecOpenSSLTransformRsaRipemd160Id
#define | xmlSecOpenSSLTransformRsaSha1Id
#define | xmlSecOpenSSLTransformRsaSha224Id
#define | xmlSecOpenSSLTransformRsaSha256Id
#define | xmlSecOpenSSLTransformRsaSha384Id
#define | xmlSecOpenSSLTransformRsaSha512Id
#define | xmlSecOpenSSLTransformRsaPkcs1Id
#define | xmlSecOpenSSLTransformRsaOaepId
#define | xmlSecOpenSSLTransformRsaOaepEnc11Id
#define | xmlSecOpenSSLTransformRsaPssSha1Id
#define | xmlSecOpenSSLTransformRsaPssSha224Id
#define | xmlSecOpenSSLTransformRsaPssSha256Id
#define | xmlSecOpenSSLTransformRsaPssSha384Id
#define | xmlSecOpenSSLTransformRsaPssSha512Id
#define | xmlSecOpenSSLTransformRsaPssSha3_224Id
#define | xmlSecOpenSSLTransformRsaPssSha3_256Id
#define | xmlSecOpenSSLTransformRsaPssSha3_384Id
#define | xmlSecOpenSSLTransformRsaPssSha3_512Id
#define | xmlSecOpenSSLKeyDataMLDSAId
#define | xmlSecOpenSSLTransformMLDSA44Id
#define | xmlSecOpenSSLTransformMLDSA65Id
#define | xmlSecOpenSSLTransformMLDSA87Id
#define | xmlSecOpenSSLKeyDataSLHDSAId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_128fId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_128sId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_192fId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_192sId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_256fId
#define | xmlSecOpenSSLTransformSLHDSA_SHA2_256sId
#define | xmlSecOpenSSLKeyDataEdDSAId
#define | xmlSecOpenSSLTransformEdDSAEd25519Id
#define | xmlSecOpenSSLTransformEdDSAEd25519ctxId
#define | xmlSecOpenSSLTransformEdDSAEd25519phId
#define | xmlSecOpenSSLTransformEdDSAEd448Id
#define | xmlSecOpenSSLTransformEdDSAEd448phId
#define | xmlSecOpenSSLKeyDataXdhId
#define | xmlSecOpenSSLTransformX25519Id
#define | xmlSecOpenSSLTransformX448Id
#define | xmlSecOpenSSLTransformSha1Id
#define | xmlSecOpenSSLTransformSha224Id
#define | xmlSecOpenSSLTransformSha256Id
#define | xmlSecOpenSSLTransformSha384Id
#define | xmlSecOpenSSLTransformSha512Id
#define | xmlSecOpenSSLTransformSha3_224Id
#define | xmlSecOpenSSLTransformSha3_256Id
#define | xmlSecOpenSSLTransformSha3_384Id
#define | xmlSecOpenSSLTransformSha3_512Id

## Description

## Functions

### xmlSecCryptoGetFunctions_openssl ()

    xmlSecCryptoDLFunctionsPtr
    xmlSecCryptoGetFunctions_openssl (void);

Gets the pointer to xmlsec-openssl functions table.

#### Returns

the xmlsec-openssl functions table or NULL if an error occurs.

### xmlSecOpenSSLInit ()

    int
    xmlSecOpenSSLInit (void);

XMLSec library specific crypto engine initialization.

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLShutdown ()

    int
    xmlSecOpenSSLShutdown (void);

XMLSec library specific crypto engine shutdown.

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeysMngrInit ()

    int
    xmlSecOpenSSLKeysMngrInit (xmlSecKeysMngrPtr mngr);

Adds OpenSSL specific key data stores in keys manager.

#### Parameters

mngr | the pointer to keys manager. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLGenerateRandom ()

    int
    xmlSecOpenSSLGenerateRandom (xmlSecBufferPtr buffer,
                                 xmlSecSize size);

Generates `size` random bytes and puts result in `buffer` .

#### Parameters

buffer | the destination buffer. |
size | the numer of bytes to generate. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLSetDefaultTrustedCertsFolder ()

    int
    xmlSecOpenSSLSetDefaultTrustedCertsFolder
                                   (const xmlChar *path);

Sets the default trusted certs folder.

#### Parameters

path | the default trusted certs path. |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLGetDefaultTrustedCertsFolder ()

    const xmlChar *
    xmlSecOpenSSLGetDefaultTrustedCertsFolder
                                   (void);

Gets the default trusted certs folder.

#### Returns

the default trusted cert folder.

### xmlSecOpenSSLSetLibCtx ()

    int
    xmlSecOpenSSLSetLibCtx (OSSL_LIB_CTX *libctx);

Sets the OSSL_LIB_CTX object to be used by xmlsec-openssl. The caller is responsible for lifetime of this object.

#### Parameters

libctx | the OSSL_LIB_CTX object to be used by xmlsec-openssl or NULL to use default. |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLGetLibCtx ()

    OSSL_LIB_CTX *
    xmlSecOpenSSLGetLibCtx (void);

Gets the current OSSL_LIB_CTX object to be used by xmlsec-openssl or NULL if the default one is used.

#### Returns

the current OSSL_LIB_CTX object or NULL if default is used.

### xmlSecOpenSSLCreateMemBio ()

    BIO *
    xmlSecOpenSSLCreateMemBio (void);

Creates a memory BIO using `xmlSecOpenSSLGetLibCtx()` for OpenSSL 3.0.

#### Returns

the pointer to BIO object or NULL if an error occurs/

### xmlSecOpenSSLCreateMemBufBio ()

    BIO *
    xmlSecOpenSSLCreateMemBufBio (const xmlSecByte *buf,
                                  xmlSecSize bufSize);

Creates a read-only memory BIO using `xmlSecOpenSSLGetLibCtx()` for OpenSSL 3.0 containing `len` bytes of data from `buf` .

#### Parameters

buf | the data |
bufSize | the data size |

#### Returns

the pointer to BIO object or NULL if an error occurs/

### xmlSecOpenSSLCreateReadFileBio ()

    BIO *
    xmlSecOpenSSLCreateReadFileBio (const char *path);

Creates a read-only file BIO using `xmlSecOpenSSLGetLibCtx()` for OpenSSL 3.0.

#### Parameters

path | the file path |

#### Returns

the pointer to BIO object or NULL if an error occurs/

### xmlSecOpenSSLKeyDataAesGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataAesGetKlass (void);

The AES key data klass.

#### Returns

AES key data klass.

### xmlSecOpenSSLKeyDataAesSet ()

    int
    xmlSecOpenSSLKeyDataAesSet (xmlSecKeyDataPtr data,
                                const xmlSecByte *buf,
                                xmlSecSize bufSize);

Sets the value of AES key data.

#### Parameters

data | the pointer to AES key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformAes128CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes128CbcGetKlass
                                   (void);

AES 128 CBC encryption transform klass.

#### Returns

pointer to AES 128 CBC encryption transform.

### xmlSecOpenSSLTransformAes192CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes192CbcGetKlass
                                   (void);

AES 192 CBC encryption transform klass.

#### Returns

pointer to AES 192 CBC encryption transform.

### xmlSecOpenSSLTransformAes256CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes256CbcGetKlass
                                   (void);

AES 256 CBC encryption transform klass.

#### Returns

pointer to AES 256 CBC encryption transform.

### xmlSecOpenSSLTransformAes128GcmGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes128GcmGetKlass
                                   (void);

AES 128 GCM encryption transform klass.

#### Returns

pointer to AES 128 GCM encryption transform.

### xmlSecOpenSSLTransformAes192GcmGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes192GcmGetKlass
                                   (void);

AES 192 GCM encryption transform klass.

#### Returns

pointer to AES 192 GCM encryption transform.

### xmlSecOpenSSLTransformAes256GcmGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformAes256GcmGetKlass
                                   (void);

AES 256 GCM encryption transform klass.

#### Returns

pointer to AES 256 GCM encryption transform.

### xmlSecOpenSSLTransformKWAes128GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWAes128GetKlass
                                   (void);

The AES-128 kew wrapper transform klass.

#### Returns

AES-128 kew wrapper transform klass.

### xmlSecOpenSSLTransformKWAes192GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWAes192GetKlass
                                   (void);

The AES-192 kew wrapper transform klass.

#### Returns

AES-192 kew wrapper transform klass.

### xmlSecOpenSSLTransformKWAes256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWAes256GetKlass
                                   (void);

The AES-256 kew wrapper transform klass.

#### Returns

AES-256 kew wrapper transform klass.

### xmlSecOpenSSLKeyDataCamelliaGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataCamelliaGetKlass (void);

The Camellia key data klass.

#### Returns

Camellia key data klass.

### xmlSecOpenSSLKeyDataCamelliaSet ()

    int
    xmlSecOpenSSLKeyDataCamelliaSet (xmlSecKeyDataPtr data,
                                     const xmlSecByte *buf,
                                     xmlSecSize bufSize);

Sets the value of Camellia key data.

#### Parameters

data | the pointer to Camellia key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformCamellia128CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformCamellia128CbcGetKlass
                                   (void);

Camellia 128 CBC encryption transform klass.

#### Returns

pointer to Camellia 128 CBC encryption transform.

### xmlSecOpenSSLTransformCamellia192CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformCamellia192CbcGetKlass
                                   (void);

Camellia 192 CBC encryption transform klass.

#### Returns

pointer to Camellia 192 CBC encryption transform.

### xmlSecOpenSSLTransformCamellia256CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformCamellia256CbcGetKlass
                                   (void);

Camellia 256 CBC encryption transform klass.

#### Returns

pointer to Camellia 256 CBC encryption transform.

### xmlSecOpenSSLTransformKWCamellia128GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWCamellia128GetKlass
                                   (void);

The Camellia-128 key wrapper transform klass.

#### Returns

Camellia-128 key wrapper transform klass.

### xmlSecOpenSSLTransformKWCamellia192GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWCamellia192GetKlass
                                   (void);

The Camellia-192 key wrapper transform klass.

#### Returns

Camellia-192 key wrapper transform klass.

### xmlSecOpenSSLTransformKWCamellia256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWCamellia256GetKlass
                                   (void);

The Camellia-256 key wrapper transform klass.

#### Returns

Camellia-256 key wrapper transform klass.

### xmlSecOpenSSLTransformChaCha20GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformChaCha20GetKlass
                                   (void);

ChaCha20 stream cipher transform.

#### Returns

pointer to ChaCha20 transform.

### xmlSecOpenSSLTransformChaCha20Poly1305GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformChaCha20Poly1305GetKlass
                                   (void);

ChaCha20-Poly1305 AEAD encryption transform.

#### Returns

pointer to ChaCha20-Poly1305 transform.

### xmlSecOpenSSLKeyDataChaCha20GetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataChaCha20GetKlass (void);

The ChaCha20 key data klass.

#### Returns

ChaCha20 key data klass.

### xmlSecOpenSSLKeyDataChaCha20Set ()

    int
    xmlSecOpenSSLKeyDataChaCha20Set (xmlSecKeyDataPtr data,
                                     const xmlSecByte *buf,
                                     xmlSecSize bufSize);

Sets the value of ChaCha20 key data.

#### Parameters

data | the pointer to ChaCha20 key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLKeyDataConcatKdfGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataConcatKdfGetKlass (void);

The ConcatKdf key data klass.

#### Returns

ConcatKdf key data klass.

### xmlSecOpenSSLKeyDataConcatKdfSet ()

    int
    xmlSecOpenSSLKeyDataConcatKdfSet (xmlSecKeyDataPtr data,
                                      const xmlSecByte *buf,
                                      xmlSecSize bufSize);

Sets the value of ConcatKdf key data.

#### Parameters

data | the pointer to ConcatKdf key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformConcatKdfGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformConcatKdfGetKlass
                                   (void);

The ConcatKDF key derivation transform klass.

#### Returns

the ConcatKDF key derivation transform klass.

### xmlSecOpenSSLKeyDataDesGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataDesGetKlass (void);

The DES key data klass.

#### Returns

DES key data klass.

### xmlSecOpenSSLKeyDataDesSet ()

    int
    xmlSecOpenSSLKeyDataDesSet (xmlSecKeyDataPtr data,
                                const xmlSecByte *buf,
                                xmlSecSize bufSize);

Sets the value of DES key data.

#### Parameters

data | the pointer to DES key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformDes3CbcGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformDes3CbcGetKlass (void);

Triple DES CBC encryption transform klass.

#### Returns

pointer to Triple DES encryption transform.

### xmlSecOpenSSLTransformKWDes3GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformKWDes3GetKlass (void);

The Triple DES key wrapper transform klass.

#### Returns

Triple DES key wrapper transform klass.

### xmlSecOpenSSLKeyDataDsaGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataDsaGetKlass (void);

The DSA key data klass.

#### Returns

pointer to DSA key data klass.

### xmlSecOpenSSLKeyDataDsaAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataDsaAdoptEvp (xmlSecKeyDataPtr data,
                                     EVP_PKEY *pKey);

Sets the DSA key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to DSA key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataDsaGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataDsaGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from DSA key data.

#### Parameters

data | the pointer to DSA key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformDsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformDsaSha1GetKlass (void);

The DSA-SHA1 signature transform klass.

#### Returns

DSA-SHA1 signature transform klass.

### xmlSecOpenSSLTransformDsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformDsaSha256GetKlass
                                   (void);

The DSA-SHA2-256 signature transform klass.

#### Returns

DSA-SHA2-256 signature transform klass.

### xmlSecOpenSSLKeyDataDhGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataDhGetKlass (void);

The DH key data klass.

#### Returns

pointer to DH key data klass.

### xmlSecOpenSSLKeyDataDhAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataDhAdoptEvp (xmlSecKeyDataPtr data,
                                    EVP_PKEY *pKey);

Sets the DH key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to DH key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataDhGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataDhGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from DH key data.

#### Parameters

data | the pointer to DH key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformDhEsGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformDhEsGetKlass (void);

The DH key agreement transform klass.

#### Returns

the DH key agreement transform klass.

### xmlSecOpenSSLKeyDataEcGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataEcGetKlass (void);

The EC key data klass.

#### Returns

pointer to EC key data klass.

### xmlSecOpenSSLKeyDataEcAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataEcAdoptEvp (xmlSecKeyDataPtr data,
                                    EVP_PKEY *pKey);

Sets the EC key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to EC key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataEcGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataEcGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from EC key data.

#### Parameters

data | the pointer to EC key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformEcdsaRipemd160GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaRipemd160GetKlass
                                   (void);

The ECDSA-RIPEMD160 signature transform klass.

#### Returns

ECDSA-RIPEMD160 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha1GetKlass
                                   (void);

The ECDSA-SHA1 signature transform klass.

#### Returns

ECDSA-SHA1 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha224GetKlass
                                   (void);

The ECDSA-SHA2-224 signature transform klass.

#### Returns

ECDSA-SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha256GetKlass
                                   (void);

The ECDSA-SHA2-256 signature transform klass.

#### Returns

ECDSA-SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha384GetKlass
                                   (void);

The ECDSA-SHA2-384 signature transform klass.

#### Returns

ECDSA-SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha512GetKlass
                                   (void);

The ECDSA-SHA2-512 signature transform klass.

#### Returns

ECDSA-SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha3_224GetKlass
                                   (void);

The ECDSA-SHA3-224 signature transform klass.

#### Returns

ECDSA-SHA3-224 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha3_256GetKlass
                                   (void);

The ECDSA-SHA3-256 signature transform klass.

#### Returns

ECDSA-SHA3-256 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha3_384GetKlass
                                   (void);

The ECDSA-SHA3-384 signature transform klass.

#### Returns

ECDSA-SHA3-384 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdsaSha3_512GetKlass
                                   (void);

The ECDSA-SHA3-512 signature transform klass.

#### Returns

ECDSA-SHA3-512 signature transform klass.

### xmlSecOpenSSLTransformEcdhGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEcdhGetKlass (void);

The ECDH key agreement transform klass.

#### Returns

the ECDH key agreement transform klass.

### xmlSecOpenSSLKeyDataGost2001GetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataGost2001GetKlass (void);

The GOST2001 key data klass.

#### Returns

pointer to GOST2001 key data klass.

### xmlSecOpenSSLTransformGostR3411_94GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGostR3411_94GetKlass
                                   (void);

GOSTR3411_94 digest transform klass.

#### Returns

pointer to GOSTR3411_94 digest transform klass.

### xmlSecOpenSSLTransformGost2001GostR3411_94GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGost2001GostR3411_94GetKlass
                                   (void);

The GOST2001-GOSTR3411_94 signature transform klass.

#### Returns

GOST2001-GOSTR3411_94 signature transform klass.

### xmlSecOpenSSLKeyDataGostR3410_2012_256GetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataGostR3410_2012_256GetKlass
                                   (void);

The GOST R 34.10-2012 256 bit key data klass.

#### Returns

pointer to GOST R 34.10-2012 256 bit key data klass.

### xmlSecOpenSSLKeyDataGostR3410_2012_512GetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataGostR3410_2012_512GetKlass
                                   (void);

The GOST R 34.10-2012 512 bit key data klass.

#### Returns

pointer to GOST R 34.10-2012 512 bit key data klass.

### xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256GetKlass
                                   (void);

The GOST R 34.10-2012 - GOST R 34.11-2012 256 bit signature transform klass.

#### Returns

GOST R 34.10-2012 - GOST R 34.11-2012 256 bit signature transform klass.

### xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512GetKlass
                                   (void);

The GOST R 34.10-2012 - GOST R 34.11-2012 512 bit signature transform klass.

#### Returns

GOST R 34.10-2012 - GOST R 34.11-2012 512 bit signature transform klass.

### xmlSecOpenSSLTransformGostR3411_2012_256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGostR3411_2012_256GetKlass
                                   (void);

GOST R 34.11-2012 256 bit digest transform klass.

#### Returns

pointer to GOST R 34.11-2012 256 bit digest transform klass.

### xmlSecOpenSSLTransformGostR3411_2012_512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformGostR3411_2012_512GetKlass
                                   (void);

GOST R 34.11-2012 512 bit digest transform klass.

#### Returns

pointer to GOST R 34.11-2012 512 bit digest transform klass.

### xmlSecOpenSSLKeyDataHmacGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataHmacGetKlass (void);

The HMAC key data klass.

#### Returns

HMAC key data klass.

### xmlSecOpenSSLKeyDataHmacSet ()

    int
    xmlSecOpenSSLKeyDataHmacSet (xmlSecKeyDataPtr data,
                                 const xmlSecByte *buf,
                                 xmlSecSize bufSize);

Sets the value of HMAC key data.

#### Parameters

data | the pointer to HMAC key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformHmacMd5GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacMd5GetKlass (void);

The HMAC-MD5 transform klass.

#### Returns

the HMAC-MD5 transform klass.

### xmlSecOpenSSLTransformHmacRipemd160GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacRipemd160GetKlass
                                   (void);

The HMAC-RIPEMD160 transform klass.

#### Returns

the HMAC-RIPEMD160 transform klass.

### xmlSecOpenSSLTransformHmacSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacSha1GetKlass
                                   (void);

The HMAC-SHA1 transform klass.

#### Returns

the HMAC-SHA1 transform klass.

### xmlSecOpenSSLTransformHmacSha224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacSha224GetKlass
                                   (void);

The HMAC-SHA224 transform klass.

#### Returns

the HMAC-SHA224 transform klass.

### xmlSecOpenSSLTransformHmacSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacSha256GetKlass
                                   (void);

The HMAC-SHA256 transform klass.

#### Returns

the HMAC-SHA256 transform klass.

### xmlSecOpenSSLTransformHmacSha384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacSha384GetKlass
                                   (void);

The HMAC-SHA384 transform klass.

#### Returns

the HMAC-SHA384 transform klass.

### xmlSecOpenSSLTransformHmacSha512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHmacSha512GetKlass
                                   (void);

The HMAC-SHA512 transform klass.

#### Returns

the HMAC-SHA512 transform klass.

### xmlSecOpenSSLTransformMd5GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformMd5GetKlass (void);

MD5 digest transform klass.

#### Returns

pointer to MD5 digest transform klass.

### xmlSecOpenSSLKeyDataPbkdf2GetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataPbkdf2GetKlass (void);

The PBKDF2 key data klass.

#### Returns

PBKDF2 key data klass.

### xmlSecOpenSSLKeyDataPbkdf2Set ()

    int
    xmlSecOpenSSLKeyDataPbkdf2Set (xmlSecKeyDataPtr data,
                                   const xmlSecByte *buf,
                                   xmlSecSize bufSize);

Sets the value of PBKDF2 key data.

#### Parameters

data | the pointer to Pbkdf2 key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformPbkdf2GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformPbkdf2GetKlass (void);

The PBKDF2 key derivation transform klass.

#### Returns

the PBKDF2 key derivation transform klass.

### xmlSecOpenSSLKeyDataHkdfGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataHkdfGetKlass (void);

The HKDF key data klass.

#### Returns

HKDF key data klass.

### xmlSecOpenSSLKeyDataHkdfSet ()

    int
    xmlSecOpenSSLKeyDataHkdfSet (xmlSecKeyDataPtr data,
                                 const xmlSecByte *buf,
                                 xmlSecSize bufSize);

Sets the value of HKDF key data (IKM).

#### Parameters

data | the pointer to Hkdf key data. |
buf | the pointer to key value. |
bufSize | the key value size (in bytes). |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecOpenSSLTransformHkdfGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformHkdfGetKlass (void);

The HKDF key derivation transform klass.

#### Returns

the HKDF key derivation transform klass.

### xmlSecOpenSSLTransformRipemd160GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRipemd160GetKlass
                                   (void);

RIPEMD-160 digest transform klass.

#### Returns

pointer to RIPEMD-160 digest transform klass.

### xmlSecOpenSSLKeyDataRsaGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataRsaGetKlass (void);

The OpenSSL RSA key data klass.

#### Returns

pointer to OpenSSL RSA key data klass.

### xmlSecOpenSSLKeyDataRsaAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataRsaAdoptEvp (xmlSecKeyDataPtr data,
                                     EVP_PKEY *pKey);

Sets the RSA key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to RSA key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataRsaGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataRsaGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from RSA key data.

#### Parameters

data | the pointer to RSA key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformRsaMd5GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaMd5GetKlass (void);

The RSA-MD5 signature transform klass.

#### Returns

RSA-MD5 signature transform klass.

### xmlSecOpenSSLTransformRsaRipemd160GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaRipemd160GetKlass
                                   (void);

The RSA-RIPEMD160 signature transform klass.

#### Returns

RSA-RIPEMD160 signature transform klass.

### xmlSecOpenSSLTransformRsaSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaSha1GetKlass (void);

The RSA-SHA1 signature transform klass.

#### Returns

RSA-SHA1 signature transform klass.

### xmlSecOpenSSLTransformRsaSha224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaSha224GetKlass
                                   (void);

The RSA-SHA2-224 signature transform klass.

#### Returns

RSA-SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformRsaSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaSha256GetKlass
                                   (void);

The RSA-SHA2-256 signature transform klass.

#### Returns

RSA-SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformRsaSha384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaSha384GetKlass
                                   (void);

The RSA-SHA2-384 signature transform klass.

#### Returns

RSA-SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformRsaSha512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaSha512GetKlass
                                   (void);

The RSA-SHA2-512 signature transform klass.

#### Returns

RSA-SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformRsaPkcs1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPkcs1GetKlass
                                   (void);

The RSA-PKCS1 key transport transform klass.

#### Returns

RSA-PKCS1 key transport transform klass.

### xmlSecOpenSSLTransformRsaOaepGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaOaepGetKlass (void);

The RSA-OAEP key transport transform klass (XMLEnc 1.0).

#### Returns

RSA-OAEP key transport transform klass.

### xmlSecOpenSSLTransformRsaOaepEnc11GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaOaepEnc11GetKlass
                                   (void);

The RSA-OAEP key transport transform klass (XMLEnc 1.1).

#### Returns

RSA-OAEP key transport transform klass.

### xmlSecOpenSSLTransformRsaPssSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha1GetKlass
                                   (void);

The RSA-PSS-SHA1 signature transform klass.

#### Returns

RSA-PSS-SHA1 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha224GetKlass
                                   (void);

The RSA-PSS-SHA2-224 signature transform klass.

#### Returns

RSA-PSS-SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha256GetKlass
                                   (void);

The RSA-PSS-SHA2-256 signature transform klass.

#### Returns

RSA-PSS-SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha384GetKlass
                                   (void);

The RSA-PSS-SHA2-384 signature transform klass.

#### Returns

RSA-PSS-SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha512GetKlass
                                   (void);

The RSA-PSS-SHA2-512 signature transform klass.

#### Returns

RSA-PSS-SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha3_224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha3_224GetKlass
                                   (void);

The RSA-PSS-SHA3-224 signature transform klass.

#### Returns

RSA-PSS-SHA3-224 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha3_256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha3_256GetKlass
                                   (void);

The RSA-PSS-SHA3-256 signature transform klass.

#### Returns

RSA-PSS-SHA3-256 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha3_384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha3_384GetKlass
                                   (void);

The RSA-PSS-SHA3-384 signature transform klass.

#### Returns

RSA-PSS-SHA3-384 signature transform klass.

### xmlSecOpenSSLTransformRsaPssSha3_512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformRsaPssSha3_512GetKlass
                                   (void);

The RSA-PSS-SHA3-512 signature transform klass.

#### Returns

RSA-PSS-SHA3-512 signature transform klass.

### xmlSecOpenSSLKeyDataMLDSAGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataMLDSAGetKlass (void);

The OpenSSL ML-DSA data klass.

#### Returns

pointer to OpenSSL ML-DSA key data klass.

### xmlSecOpenSSLKeyDataMLDSAAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataMLDSAAdoptEvp (xmlSecKeyDataPtr data,
                                       EVP_PKEY *pKey);

Sets the MLDSA key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to MLDSA key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataMLDSAGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataMLDSAGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from MLDSA key data.

#### Parameters

data | the pointer to MLDSA key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLKeyDataMLDSAGetKL ()

    int
    xmlSecOpenSSLKeyDataMLDSAGetKL (xmlSecKeyDataPtr data);

Gets ML-DSA key (k, l) value: 44 corresponds to (4,4), 65 to (6,5) or 87 to (8,7).

#### Parameters

data | the pointer to MLDSA key data. |

#### Returns

44, 65, or 87 on success or a negative value otherwise.

### xmlSecOpenSSLTransformMLDSA44GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformMLDSA44GetKlass (void);

The ML-DSA-44 signature transform klass.

#### Returns

ML-DSA-44 signature transform klass.

### xmlSecOpenSSLTransformMLDSA65GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformMLDSA65GetKlass (void);

The ML-DSA-65 signature transform klass.

#### Returns

ML-DSA-65 signature transform klass.

### xmlSecOpenSSLTransformMLDSA87GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformMLDSA87GetKlass (void);

### xmlSecOpenSSLKeyDataSLHDSAGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataSLHDSAGetKlass (void);

The OpenSSL SLH-DSA data klass.

#### Returns

pointer to OpenSSL SLH-DSA key data klass.

### xmlSecOpenSSLKeyDataSLHDSAAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataSLHDSAAdoptEvp (xmlSecKeyDataPtr data,
                                        EVP_PKEY *pKey);

Sets the SLHDSA key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to SLHDSA key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataSLHDSAGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataSLHDSAGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from SLHDSA key data.

#### Parameters

data | the pointer to SLHDSA key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformSLHDSA_SHA2_128fGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_128fGetKlass
                                   (void);

The SLH-DSA-SHA2-128f signature transform klass.

#### Returns

SLH-DSA-SHA2-128f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_128sGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_128sGetKlass
                                   (void);

The SLH-DSA-SHA2-128s signature transform klass.

#### Returns

SLH-DSA-SHA2-128s signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_192fGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_192fGetKlass
                                   (void);

The SLH-DSA-SHA2-192f signature transform klass.

#### Returns

SLH-DSA-SHA2-192f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_192sGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_192sGetKlass
                                   (void);

The SLH-DSA-SHA2-192s signature transform klass.

#### Returns

SLH-DSA-SHA2-192s signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_256fGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_256fGetKlass
                                   (void);

The SLH-DSA-SHA2-256f signature transform klass.

#### Returns

SLH-DSA-SHA2-256f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_256sGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSLHDSA_SHA2_256sGetKlass
                                   (void);

The SLH-DSA-SHA2-256s signature transform klass.

#### Returns

SLH-DSA-SHA2-256s signature transform klass.

### xmlSecOpenSSLKeyDataEdDSAGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataEdDSAGetKlass (void);

The OpenSSL EdDSA data klass.

#### Returns

pointer to OpenSSL EdDSA key data klass.

### xmlSecOpenSSLKeyDataEdDSAAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataEdDSAAdoptEvp (xmlSecKeyDataPtr data,
                                       EVP_PKEY *pKey);

Sets the EdDSA key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to EdDSA key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataEdDSAGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataEdDSAGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from EdDSA key data.

#### Parameters

data | the pointer to EdDSA key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformEdDSAEd25519GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEdDSAEd25519GetKlass
                                   (void);

The EdDSA-Ed25519 signature transform klass.

#### Returns

EdDSA-Ed25519 signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd25519ctxGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEdDSAEd25519ctxGetKlass
                                   (void);

The EdDSA-Ed25519ctx signature transform klass.

#### Returns

EdDSA-Ed25519ctx signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd25519phGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEdDSAEd25519phGetKlass
                                   (void);

The EdDSA-Ed25519ph signature transform klass.

#### Returns

EdDSA-Ed25519ph signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd448GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEdDSAEd448GetKlass
                                   (void);

The EdDSA-Ed448 signature transform klass.

#### Returns

EdDSA-Ed448 signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd448phGetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformEdDSAEd448phGetKlass
                                   (void);

The EdDSA-Ed448ph signature transform klass.

#### Returns

EdDSA-Ed448ph signature transform klass.

### xmlSecOpenSSLKeyDataXdhGetKlass ()

    xmlSecKeyDataId
    xmlSecOpenSSLKeyDataXdhGetKlass (void);

The OpenSSL XDH data klass.

#### Returns

pointer to OpenSSL XDH key data klass.

### xmlSecOpenSSLKeyDataXdhAdoptEvp ()

    int
    xmlSecOpenSSLKeyDataXdhAdoptEvp (xmlSecKeyDataPtr data,
                                     EVP_PKEY *pKey);

Sets the XDH key data value to OpenSSL EVP key.

#### Parameters

data | the pointer to XDH key data. |
pKey | the pointer to OpenSSL EVP key. |

#### Returns

0 on success or a negative value otherwise.

### xmlSecOpenSSLKeyDataXdhGetEvp ()

    EVP_PKEY *
    xmlSecOpenSSLKeyDataXdhGetEvp (xmlSecKeyDataPtr data);

Gets the OpenSSL EVP key from XDH key data.

#### Parameters

data | the pointer to XDH key data. |

#### Returns

pointer to OpenSSL EVP key or NULL if an error occurs.

### xmlSecOpenSSLTransformX25519GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformX25519GetKlass (void);

The X25519 key agreement transform klass.

#### Returns

the X25519 key agreement transform klass.

### xmlSecOpenSSLTransformX448GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformX448GetKlass (void);

The X448 key agreement transform klass.

#### Returns

the X448 key agreement transform klass.

### xmlSecOpenSSLTransformSha1GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha1GetKlass (void);

SHA-1 digest transform klass.

#### Returns

pointer to SHA-1 digest transform klass.

### xmlSecOpenSSLTransformSha224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha224GetKlass (void);

SHA2-224 digest transform klass.

#### Returns

pointer to SHA2-224 digest transform klass.

### xmlSecOpenSSLTransformSha256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha256GetKlass (void);

SHA2-256 digest transform klass.

#### Returns

pointer to SHA2-256 digest transform klass.

### xmlSecOpenSSLTransformSha384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha384GetKlass (void);

SHA2-384 digest transform klass.

#### Returns

pointer to SHA2-384 digest transform klass.

### xmlSecOpenSSLTransformSha512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha512GetKlass (void);

SHA2-512 digest transform klass.

#### Returns

pointer to SHA2-512 digest transform klass.

### xmlSecOpenSSLTransformSha3_224GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha3_224GetKlass
                                   (void);

SHA3-224 digest transform klass.

#### Returns

pointer to SHA3-224 digest transform klass.

### xmlSecOpenSSLTransformSha3_256GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha3_256GetKlass
                                   (void);

SHA3-256 digest transform klass.

#### Returns

pointer to SHA3-256 digest transform klass.

### xmlSecOpenSSLTransformSha3_384GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha3_384GetKlass
                                   (void);

SHA3-384 digest transform klass.

#### Returns

pointer to SHA3-384 digest transform klass.

### xmlSecOpenSSLTransformSha3_512GetKlass ()

    xmlSecTransformId
    xmlSecOpenSSLTransformSha3_512GetKlass
                                   (void);

SHA3-512 digest transform klass.

#### Returns

pointer to SHA3-512 digest transform klass.

### xmlSecOpenSSLErrorsDefaultCallback ()

    void
    xmlSecOpenSSLErrorsDefaultCallback (const char *file,
                                        int line,
                                        const char *func,
                                        const char *errorObject,
                                        const char *errorSubject,
                                        int reason,
                                        const char *msg);

The errors reporting callback function.

#### Parameters

file | the error location file name (__FILE__ macro). |
line | the error location line number (__LINE__ macro). |
func | the error location function name (__FUNCTION__ macro). |
errorObject | the error specific error object |
errorSubject | the error specific error subject. |
reason | the error code. |
msg | the additional error message. |

## Types and Values

### XMLSEC_OPENSSL_API_111

    #define XMLSEC_OPENSSL_API_111      1

### XMLSEC_OPENSSL_API_350

    #define XMLSEC_OPENSSL_API_350      1

### XMLSEC_OPENSSL_API_300

    #define XMLSEC_OPENSSL_API_300      1

### XMLSEC_NO_AES

    #define XMLSEC_NO_AES       1

### XMLSEC_NO_CONCATKDF

    #define XMLSEC_NO_CONCATKDF  1

### XMLSEC_NO_PBKDF2

    #define XMLSEC_NO_PBKDF2     1

### XMLSEC_NO_HKDF

    #define XMLSEC_NO_HKDF       1

### XMLSEC_NO_DES

    #define XMLSEC_NO_DES       1

### XMLSEC_NO_DSA

    #define XMLSEC_NO_DSA       1

### XMLSEC_NO_EC

    #define XMLSEC_NO_EC     1

### XMLSEC_NO_GOST

    #define XMLSEC_NO_GOST      1

### XMLSEC_NO_GOST2012

    #define XMLSEC_NO_GOST2012  1

### XMLSEC_NO_HMAC

    #define XMLSEC_NO_HMAC      1

### XMLSEC_NO_MD5

    #define XMLSEC_NO_MD5       1

### XMLSEC_NO_RIPEMD160

    #define XMLSEC_NO_RIPEMD160 1

### XMLSEC_NO_RSA

    #define XMLSEC_NO_RSA       1

### XMLSEC_NO_MLDSA

    #define XMLSEC_NO_MLDSA      1

### XMLSEC_NO_SLHDSA

    #define XMLSEC_NO_SLHDSA      1

### XMLSEC_NO_EDDSA

    #define XMLSEC_NO_EDDSA       1

### XMLSEC_NO_SHA1

    #define XMLSEC_NO_SHA1      1

### XMLSEC_NO_SHA256

    #define XMLSEC_NO_SHA256    1

### XMLSEC_NO_SHA224

    #define XMLSEC_NO_SHA224    1

### XMLSEC_NO_SHA384

    #define XMLSEC_NO_SHA384    1

### XMLSEC_NO_SHA512

    #define XMLSEC_NO_SHA512    1

### XMLSEC_NO_X509

    #define XMLSEC_NO_X509      1

### xmlSecOpenSSLKeyDataAesId

    #define             xmlSecOpenSSLKeyDataAesId

The AES key klass.

### xmlSecOpenSSLTransformAes128CbcId

    #define             xmlSecOpenSSLTransformAes128CbcId

The AES128 CBC cipher transform klass.

### xmlSecOpenSSLTransformAes192CbcId

    #define             xmlSecOpenSSLTransformAes192CbcId

The AES192 CBC cipher transform klass.

### xmlSecOpenSSLTransformAes256CbcId

    #define             xmlSecOpenSSLTransformAes256CbcId

The AES256 CBC cipher transform klass.

### xmlSecOpenSSLTransformAes128GcmId

    #define             xmlSecOpenSSLTransformAes128GcmId

The AES128 GCM cipher transform klass.

### xmlSecOpenSSLTransformAes192GcmId

    #define             xmlSecOpenSSLTransformAes192GcmId

The AES192 GCM cipher transform klass.

### xmlSecOpenSSLTransformAes256GcmId

    #define             xmlSecOpenSSLTransformAes256GcmId

The AES256 GCM cipher transform klass.

### xmlSecOpenSSLTransformKWAes128Id

    #define             xmlSecOpenSSLTransformKWAes128Id

The AES 128 key wrap transform klass.

### xmlSecOpenSSLTransformKWAes192Id

    #define             xmlSecOpenSSLTransformKWAes192Id

The AES 192 key wrap transform klass.

### xmlSecOpenSSLTransformKWAes256Id

    #define             xmlSecOpenSSLTransformKWAes256Id

The AES 256 key wrap transform klass.

### xmlSecOpenSSLKeyDataCamelliaId

    #define             xmlSecOpenSSLKeyDataCamelliaId

The Camellia key klass.

### xmlSecOpenSSLTransformCamellia128CbcId

    #define             xmlSecOpenSSLTransformCamellia128CbcId

The Camellia128 CBC cipher transform klass.

### xmlSecOpenSSLTransformCamellia192CbcId

    #define             xmlSecOpenSSLTransformCamellia192CbcId

The Camellia192 CBC cipher transform klass.

### xmlSecOpenSSLTransformCamellia256CbcId

    #define             xmlSecOpenSSLTransformCamellia256CbcId

The Camellia256 CBC cipher transform klass.

### xmlSecOpenSSLTransformKWCamellia128Id

    #define             xmlSecOpenSSLTransformKWCamellia128Id

The Camellia 128 key wrap transform klass.

### xmlSecOpenSSLTransformKWCamellia192Id

    #define             xmlSecOpenSSLTransformKWCamellia192Id

The Camellia 192 key wrap transform klass.

### xmlSecOpenSSLTransformKWCamellia256Id

    #define             xmlSecOpenSSLTransformKWCamellia256Id

The Camellia 256 key wrap transform klass.

### xmlSecOpenSSLTransformChaCha20Id

    #define             xmlSecOpenSSLTransformChaCha20Id

The ChaCha20 stream cipher transform klass.

### xmlSecOpenSSLTransformChaCha20Poly1305Id

    #define             xmlSecOpenSSLTransformChaCha20Poly1305Id

The ChaCha20-Poly1305 AEAD transform klass.

### xmlSecOpenSSLKeyDataChaCha20Id

    #define             xmlSecOpenSSLKeyDataChaCha20Id

The ChaCha20 key data klass.

### xmlSecOpenSSLKeyDataConcatKdfId

    #define             xmlSecOpenSSLKeyDataConcatKdfId

The ConcatKDF key derivation key klass.

### xmlSecOpenSSLTransformConcatKdfId

    #define             xmlSecOpenSSLTransformConcatKdfId

The ConcatKDF key derivation transform klass.

### xmlSecOpenSSLKeyDataDesId

    #define             xmlSecOpenSSLKeyDataDesId

The DES key klass.

### xmlSecOpenSSLTransformDes3CbcId

    #define             xmlSecOpenSSLTransformDes3CbcId

The DES3 CBC cipher transform klass.

### xmlSecOpenSSLTransformKWDes3Id

    #define             xmlSecOpenSSLTransformKWDes3Id

The DES3 KW transform klass.

### xmlSecOpenSSLKeyDataDsaId

    #define             xmlSecOpenSSLKeyDataDsaId

The DSA key klass.

### xmlSecOpenSSLTransformDsaSha1Id

    #define             xmlSecOpenSSLTransformDsaSha1Id

The DSA SHA1 signature transform klass.

### xmlSecOpenSSLTransformDsaSha256Id

    #define             xmlSecOpenSSLTransformDsaSha256Id

The DSA SHA2-256 signature transform klass.

### xmlSecOpenSSLKeyDataDhId

    #define             xmlSecOpenSSLKeyDataDhId

The DH key klass.

### xmlSecOpenSSLTransformDhEsId

    #define             xmlSecOpenSSLTransformDhEsId

The DH key agreement transform klass.

### xmlSecOpenSSLKeyDataEcId

    #define xmlSecOpenSSLKeyDataEcId        xmlSecOpenSSLKeyDataEcGetKlass()

The EC key klass.

### xmlSecOpenSSLTransformEcdsaRipemd160Id

    #define             xmlSecOpenSSLTransformEcdsaRipemd160Id

The ECDSA-RIPEMD160 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha1Id

    #define             xmlSecOpenSSLTransformEcdsaSha1Id

The ECDSA-SHA1 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha224Id

    #define             xmlSecOpenSSLTransformEcdsaSha224Id

The ECDSA-SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha256Id

    #define             xmlSecOpenSSLTransformEcdsaSha256Id

The ECDSA-SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha384Id

    #define             xmlSecOpenSSLTransformEcdsaSha384Id

The ECDSA-SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha512Id

    #define             xmlSecOpenSSLTransformEcdsaSha512Id

The ECDSA-SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_224Id

    #define             xmlSecOpenSSLTransformEcdsaSha3_224Id

The ECDSA-SHA3-224 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_256Id

    #define             xmlSecOpenSSLTransformEcdsaSha3_256Id

The ECDSA-SHA3-256 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_384Id

    #define             xmlSecOpenSSLTransformEcdsaSha3_384Id

The ECDSA-SHA3-384 signature transform klass.

### xmlSecOpenSSLTransformEcdsaSha3_512Id

    #define             xmlSecOpenSSLTransformEcdsaSha3_512Id

The ECDSA-SHA3-512 signature transform klass.

### xmlSecOpenSSLTransformEcdhId

    #define             xmlSecOpenSSLTransformEcdhId

The ECDH key agreement transform klass.

### xmlSecOpenSSLKeyDataGost2001Id

    #define             xmlSecOpenSSLKeyDataGost2001Id

The GOST2001 key klass.

### xmlSecOpenSSLTransformGostR3411_94Id

    #define             xmlSecOpenSSLTransformGostR3411_94Id

The GOSTR3411_94 digest transform klass.

### xmlSecOpenSSLTransformGost2001GostR3411_94Id

    #define             xmlSecOpenSSLTransformGost2001GostR3411_94Id

The GOST2001 GOSTR3411_94 signature transform klass.

### xmlSecOpenSSLKeyDataGostR3410_2012_256Id

    #define             xmlSecOpenSSLKeyDataGostR3410_2012_256Id

The GOST R 34.10-2012 256 key klass.

### xmlSecOpenSSLKeyDataGostR3410_2012_512Id

    #define             xmlSecOpenSSLKeyDataGostR3410_2012_512Id

The GOST R 34.10-2012 512 key klass.

### xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256Id

    #define             xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_256Id

The GOST R 34.10-2012 - GOST R 3411-2012 256 bit signature transform klass.

### xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512Id

    #define             xmlSecOpenSSLTransformGostR3410_2012GostR3411_2012_512Id

The GOST R 34.10-2012 - GOST R 3411-2012 512 bit signature transform klass.

### xmlSecOpenSSLTransformGostR3411_2012_256Id

    #define             xmlSecOpenSSLTransformGostR3411_2012_256Id

The GOST R 34.11-2012 256 bit hash transform klass.

### xmlSecOpenSSLTransformGostR3411_2012_512Id

    #define             xmlSecOpenSSLTransformGostR3411_2012_512Id

The GOST R 34.11-2012 512 bit hash transform klass.

### xmlSecOpenSSLKeyDataHmacId

    #define             xmlSecOpenSSLKeyDataHmacId

The HMAC key klass.

### xmlSecOpenSSLTransformHmacMd5Id

    #define             xmlSecOpenSSLTransformHmacMd5Id

The HMAC with MD5 signature transform klass.

### xmlSecOpenSSLTransformHmacRipemd160Id

    #define             xmlSecOpenSSLTransformHmacRipemd160Id

The HMAC with RipeMD160 signature transform klass.

### xmlSecOpenSSLTransformHmacSha1Id

    #define             xmlSecOpenSSLTransformHmacSha1Id

The HMAC with SHA1 signature transform klass.

### xmlSecOpenSSLTransformHmacSha224Id

    #define             xmlSecOpenSSLTransformHmacSha224Id

The HMAC with SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformHmacSha256Id

    #define             xmlSecOpenSSLTransformHmacSha256Id

The HMAC with SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformHmacSha384Id

    #define             xmlSecOpenSSLTransformHmacSha384Id

The HMAC with SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformHmacSha512Id

    #define             xmlSecOpenSSLTransformHmacSha512Id

The HMAC with SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformMd5Id

    #define             xmlSecOpenSSLTransformMd5Id

The MD5 digest transform klass.

### xmlSecOpenSSLKeyDataPbkdf2Id

    #define             xmlSecOpenSSLKeyDataPbkdf2Id

The Pbkdf2 key derivation key klass.

### xmlSecOpenSSLTransformPbkdf2Id

    #define             xmlSecOpenSSLTransformPbkdf2Id

The PBKDF2 key derivation transform klass.

### xmlSecOpenSSLKeyDataHkdfId

    #define             xmlSecOpenSSLKeyDataHkdfId

The Hkdf key derivation key klass.

### xmlSecOpenSSLTransformHkdfId

    #define             xmlSecOpenSSLTransformHkdfId

The HKDF key derivation transform klass.

### xmlSecOpenSSLTransformRipemd160Id

    #define             xmlSecOpenSSLTransformRipemd160Id

The RIPEMD160 digest transform klass.

### xmlSecOpenSSLKeyDataRsaId

    #define             xmlSecOpenSSLKeyDataRsaId

The RSA key klass.

### xmlSecOpenSSLTransformRsaMd5Id

    #define             xmlSecOpenSSLTransformRsaMd5Id

The RSA-MD5 signature transform klass.

### xmlSecOpenSSLTransformRsaRipemd160Id

    #define             xmlSecOpenSSLTransformRsaRipemd160Id

The RSA-RIPEMD160 signature transform klass.

### xmlSecOpenSSLTransformRsaSha1Id

    #define             xmlSecOpenSSLTransformRsaSha1Id

The RSA-SHA1 signature transform klass.

### xmlSecOpenSSLTransformRsaSha224Id

    #define             xmlSecOpenSSLTransformRsaSha224Id

The RSA-SHA2-224 signature transform klass.

### xmlSecOpenSSLTransformRsaSha256Id

    #define             xmlSecOpenSSLTransformRsaSha256Id

The RSA-SHA2-256 signature transform klass.

### xmlSecOpenSSLTransformRsaSha384Id

    #define             xmlSecOpenSSLTransformRsaSha384Id

The RSA-SHA2-384 signature transform klass.

### xmlSecOpenSSLTransformRsaSha512Id

    #define             xmlSecOpenSSLTransformRsaSha512Id

The RSA-SHA2-512 signature transform klass.

### xmlSecOpenSSLTransformRsaPkcs1Id

    #define             xmlSecOpenSSLTransformRsaPkcs1Id

The RSA PKCS1 key transport transform klass.

### xmlSecOpenSSLTransformRsaOaepId

    #define             xmlSecOpenSSLTransformRsaOaepId

The RSA PKCS1 key transport transform klass (XMLEnc 1.0).

### xmlSecOpenSSLTransformRsaOaepEnc11Id

    #define             xmlSecOpenSSLTransformRsaOaepEnc11Id

The RSA PKCS1 key transport transform klass (XMLEnc 1.1).

### xmlSecOpenSSLTransformRsaPssSha1Id

    #define             xmlSecOpenSSLTransformRsaPssSha1Id

The RSA-PSS-SHA1 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha224Id

    #define             xmlSecOpenSSLTransformRsaPssSha224Id

The RSA-PSS-SHA2-224 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha256Id

    #define             xmlSecOpenSSLTransformRsaPssSha256Id

The RSA-PSS-SHA2-256 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha384Id

    #define             xmlSecOpenSSLTransformRsaPssSha384Id

The RSA-PSS-SHA2-384 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha512Id

    #define             xmlSecOpenSSLTransformRsaPssSha512Id

The RSA-PSS-SHA2-512 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha3_224Id

    #define             xmlSecOpenSSLTransformRsaPssSha3_224Id

The RSA-PSS-SHA3-224 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha3_256Id

    #define             xmlSecOpenSSLTransformRsaPssSha3_256Id

The RSA-PSS-SHA3-256 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha3_384Id

    #define             xmlSecOpenSSLTransformRsaPssSha3_384Id

The RSA-PSS-SHA3-384 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLTransformRsaPssSha3_512Id

    #define             xmlSecOpenSSLTransformRsaPssSha3_512Id

The RSA-PSS-SHA3-512 signature transform klass (https://www.rfc-editor.org/rfc/rfc9231.txt).

### xmlSecOpenSSLKeyDataMLDSAId

    #define             xmlSecOpenSSLKeyDataMLDSAId

The ML-DSA key klass.

### xmlSecOpenSSLTransformMLDSA44Id

    #define             xmlSecOpenSSLTransformMLDSA44Id

The ML-DSA-44 signature transform klass.

### xmlSecOpenSSLTransformMLDSA65Id

    #define             xmlSecOpenSSLTransformMLDSA65Id

The ML-DSA-65 signature transform klass.

### xmlSecOpenSSLTransformMLDSA87Id

    #define             xmlSecOpenSSLTransformMLDSA87Id

The ML-DSA-87 signature transform klass.

### xmlSecOpenSSLKeyDataSLHDSAId

    #define             xmlSecOpenSSLKeyDataSLHDSAId

The SLH-DSA key klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_128fId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_128fId

The SLH-DSA-SHA2-128f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_128sId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_128sId

The SLH-DSA-SHA2-128s signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_192fId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_192fId

The SLH-DSA-SHA2-192f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_192sId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_192sId

The SLH-DSA-SHA2-192s signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_256fId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_256fId

The SLH-DSA-SHA2-256f signature transform klass.

### xmlSecOpenSSLTransformSLHDSA_SHA2_256sId

    #define             xmlSecOpenSSLTransformSLHDSA_SHA2_256sId

The SLH-DSA-SHA2-256s signature transform klass.

### xmlSecOpenSSLKeyDataEdDSAId

    #define             xmlSecOpenSSLKeyDataEdDSAId

The EdDSA key klass.

### xmlSecOpenSSLTransformEdDSAEd25519Id

    #define             xmlSecOpenSSLTransformEdDSAEd25519Id

The EdDSA-Ed25519 signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd25519ctxId

    #define             xmlSecOpenSSLTransformEdDSAEd25519ctxId

The EdDSA-Ed25519ctx signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd25519phId

    #define             xmlSecOpenSSLTransformEdDSAEd25519phId

The EdDSA-Ed25519ph signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd448Id

    #define             xmlSecOpenSSLTransformEdDSAEd448Id

The EdDSA-Ed448 signature transform klass.

### xmlSecOpenSSLTransformEdDSAEd448phId

    #define             xmlSecOpenSSLTransformEdDSAEd448phId

The EdDSA-Ed448ph signature transform klass.

### xmlSecOpenSSLKeyDataXdhId

    #define             xmlSecOpenSSLKeyDataXdhId

The XDH key klass.

### xmlSecOpenSSLTransformX25519Id

    #define             xmlSecOpenSSLTransformX25519Id

The X25519 key agreement transform klass.

### xmlSecOpenSSLTransformX448Id

    #define             xmlSecOpenSSLTransformX448Id

The X448 key agreement transform klass.

### xmlSecOpenSSLTransformSha1Id

    #define             xmlSecOpenSSLTransformSha1Id

The SHA1 digest transform klass.

### xmlSecOpenSSLTransformSha224Id

    #define             xmlSecOpenSSLTransformSha224Id

The SHA2-224 digest transform klass.

### xmlSecOpenSSLTransformSha256Id

    #define             xmlSecOpenSSLTransformSha256Id

The SHA2-256 digest transform klass.

### xmlSecOpenSSLTransformSha384Id

    #define             xmlSecOpenSSLTransformSha384Id

The SHA2-384 digest transform klass.

### xmlSecOpenSSLTransformSha512Id

    #define             xmlSecOpenSSLTransformSha512Id

The SHA2-512 digest transform klass.

### xmlSecOpenSSLTransformSha3_224Id

    #define             xmlSecOpenSSLTransformSha3_224Id

The SHA3-224 digest transform klass.

### xmlSecOpenSSLTransformSha3_256Id

    #define             xmlSecOpenSSLTransformSha3_256Id

The SHA3-256 digest transform klass.

### xmlSecOpenSSLTransformSha3_384Id

    #define             xmlSecOpenSSLTransformSha3_384Id

The SHA3-384 digest transform klass.

### xmlSecOpenSSLTransformSha3_512Id

    #define             xmlSecOpenSSLTransformSha3_512Id

The SHA3-512 digest transform klass.